| Flutter Impeller |

Public Member Functions | Static Public Member Functions | List of all members
impeller::PointFieldGeometry Class Reference

`#include <point_field_geometry.h>`

Inheritance diagram for impeller::PointFieldGeometry:

## Public Member Functions
| PointFieldGeometry (std::vector< Point > points, Scalar radius, bool round)
| ~PointFieldGeometry ()
Public Member Functions inherited from impeller::Geometry
| Geometry ()
virtual | ~Geometry ()
virtual bool | CoversArea (const Matrix &transform, const Rect &rect) const
| Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`. More...

## Static Public Member Functions
static size_t | ComputeCircleDivisions (Scalar scaled_radius, bool round)
| Compute the number of vertices to divide each circle into. More...
Static Public Member Functions inherited from impeller::Geometry
static std::unique_ptr< Geometry > | MakeFillPath (const Path &path, std::optional< Rect > inner_rect=std::nullopt)
static std::unique_ptr< Geometry > | MakeStrokePath (const Path &path, Scalar stroke_width=0.0, Scalar miter_limit=4.0, Cap stroke_cap=Cap::kButt, Join stroke_join=Join::kMiter)
static std::unique_ptr< Geometry > | MakeCover ()
static std::unique_ptr< Geometry > | MakeRect (Rect rect)
static std::unique_ptr< Geometry > | MakePointField (std::vector< Point > points, Scalar radius, bool round)

## Detailed Description

Definition at line 11 of file point_field_geometry.h.

## Constructor & Destructor Documentation

## ◆ PointFieldGeometry()

impeller::PointFieldGeometry::PointFieldGeometry | ( | std::vector< Point > | points,
|  | Scalar | radius,
|  | bool | round
| ) |  |

Definition at line 12 of file point_field_geometry.cc.

15 : points_(std::move(points)), radius_(radius), round_(round) {}

## ◆ ~PointFieldGeometry()

impeller::PointFieldGeometry::~PointFieldGeometry | ( |  | ) |
| default

## Member Function Documentation

## ◆ ComputeCircleDivisions()

size_t impeller::PointFieldGeometry::ComputeCircleDivisions | ( | Scalar | scaled_radius,
|  | bool | round
| ) |  |
| static

Compute the number of vertices to divide each circle into.

Returns
  the number of vertices.

Definition at line 244 of file point_field_geometry.cc.

245 {
246 if (!round) {
247 return 4;
248 }
249
250 // Note: these values are approximated based on the values returned from
251 // the decomposition of 4 cubics performed by Path::CreatePolyline.
252 if (scaled_radius < 1.0) {
253 return 4;
254 }
255 if (scaled_radius < 2.0) {
256 return 8;
257 }
258 if (scaled_radius < 12.0) {
259 return 24;
260 }
261 if (scaled_radius < 22.0) {
262 return 34;
263 }
264 return std::min(scaled_radius, 140.0f);
265 }

Referenced by impeller::testing::TEST_P().

The documentation for this class was generated from the following files:

- impeller/entity/geometry/point_field_geometry.h
- impeller/entity/geometry/point_field_geometry.cc